from matrix import API as MatrixAPI
import sys

USER_CODE = 1429421

# Instantiate API class in Matrix module
mxAPI = MatrixAPI()

print("count", mxAPI.count())
print("mem_size", mxAPI.mem_size(1))
print("model", mxAPI.model(1))

dng_ver = mxAPI.version(1)
print("version", (dng_ver & 0xffff0000) >> 16, ".", dng_ver & 0xffff )

api_ver = mxAPI.api_version()
print("api_ver", (api_ver & 0xffff0000) >> 16, ".",  (api_ver & 0xffff) )

drv_ver = mxAPI.drv_version()
print("drv_ver", (drv_ver & 0xffff0000) >> 16, ".",  (drv_ver & 0xffff))

print("serNr", mxAPI.ser_no(USER_CODE,1))

#
# Read / Write Memory
#
ret, fields = mxAPI.read_data(USER_CODE,15,1)
print(" ---- read_data ----")
if ret == 15:
    for i in fields:
        print(i)

print(" ---- read_data_ex ----")
ret, fields = mxAPI.read_data_ex(USER_CODE,10,6, 1)
if ret == 6:
    for i in fields:
        print(i)

print("write_data:",  mxAPI.write_data(USER_CODE, [12345, 54321], 1) )
ret, fields = mxAPI.read_data(USER_CODE,15,1)
print(" ---- read_data ----")
if ret == 15:
    for i in fields:
        print(i)

#
# Write Encryption Key
#
if mxAPI.write_key(USER_CODE, [1234567890, 987654321,1234567890, 987654321], 1) > 0:
    print("WriteKey successful")
else:
    print("WriteKey failed")

#
# Encrypt / Decrypt
#
ret, enc_data = mxAPI.encrypt_data(USER_CODE, [1234567890, 987654321], 1)
if ret > 0:
    print("enc_data:", enc_data[0], enc_data[1])

ret, plain_data = mxAPI.decrypt_data(USER_CODE, enc_data, 1)
if ret > 0:
    print("plain_data:", plain_data[0], plain_data[1])

#
# Network API
#
# Activate Network API
if mxAPI.setconfig_matrixnet(1, "c:\\temp\\mxnet2.dat") != 1:
    print("setconfig_matrixnet: not activated")
    sys.exit(0)

print("Network API activated")

# Obtain a license from AppSlot 7
print("login:" ,mxAPI.login(USER_CODE, 7,1))

input("press a key:")

# Return the license to AppSlot 7
print("logout", mxAPI.logout(USER_CODE, 7,1))





